<template>
  <div>
    <div>
<CModal
      title="Info"
      size="sm"
      :show.sync="smallModal">
      {{ SuccessMsg }}

</CModal>

  
<CCardBody>
     <h5>PPC Schedule</h5>
    <form class="form-inline">
    <h6> Dual    </h6>
  <div class="form-group mx-sm-2 mb-2">
    
    <label for="Dual" class="sr-only" id="Dual">Dual</label>
        <select class="form-control" v-model="searchdata.dualid" @change="getAllManualEntryfordate_dual();">
    <!-- <option value= "Select Material Type" selected disabled>Select Material Type</option> -->
    <option v-for="wcitem in wcitems" :value="wcitem.workCent_Id" :key="wcitem.workCent_Id">{{wcitem.workCent_Name}} </option>
  </select>
          <!-- <select class="form-control form-control-sm" id="Dual"  v-model="searchdata.dualid"  @change ="getAllManualEntryfordate_dual()"><option value="1" >Dual1</option> <option value="2">Dual2</option></select> -->
    <!-- <input type="text" readonly class="form-control-plaintext" id="staticEmail2" value="email@example.com"> -->
  </div>
<h6>Date</h6>
  <div class="form-group mx-sm-3 mb-2">
  
<input type="date" name="FromDate" class="form-control form-control-sm" placeholder="From" v-model="searchdata.fromdate">
 <div > </div>
<input type="date" name="ToDate" class="form-control form-control-sm" placeholder="To" v-model="searchdata.todate">
    
  </div>
    <CButton size="sm" color="dark" class="ml-1" @click="getAllManualEntryfordate_dual()"> Search </CButton> 
  
</form>
    <CDataTable
    
      :items="items"
      :fields="fields"
      table-filter
      items-per-page-select
      :items-per-page="10"
      pagination
      hover
      striped
      border
     
     >
   
    
<!--Adding Customs buttons to each row -->
       <template #show_details="{item}" >      
      <CButton size="sm" color="dark" class="ml-1" @click="SelectEntry(item); ShowDetailModal=true; getAllMHEDetails();getAllStorageLocDetails()"> Production Entry </CButton>
      <!-- <CButton size="sm" color="danger" class="ml-1" @click="ShowDeleteModal=true; SelectEntry(item)" >Delete</CButton> -->
    
    </template>

    </CDataTable>
    
  </CCardBody>

 </div>

<!-- Show Details Modal -->
<div id="overlay" v-if="ShowDetailModal">
<div class="modal-dialog  modal-lg" >
<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">Production Details</h5>
    <button type="button" class="close"  @click="ShowDetailModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
<div class="modal-body modal-lg">

<form >

  <div>
        <!-- <CListGroupItem href="#" color="secondary"> -->
    <CRow>
       <CCol sm="2" > Item Code</CCol>
      <CCol sm="3">
        <CInput
          readonly
          v-model = this.CurrentEntry.ext_Code
        />
      </CCol>
      <CCol sm="2" > Color Code</CCol>
      <CCol sm="3">
        <CInput
         readonly
         v-model   = this.CurrentEntry.size_Code
        />
      </CCol>
    </CRow>
       
    <CRow>
      <CCol sm="2" > Date</CCol>
      <CCol sm="3">
        <CInput
         readonly
           v-model   = this.CurrentEntry.prod_Date
        />
      </CCol>

            <CCol sm="2" >Time</CCol>
      <CCol >

        <CSelect 
          label= "HH"
          placeholder="00"
          @change="valueHasChangedhr"
        
          :options="[0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23]"
        />
        </CCol>
        <CCol >
         <CSelect
         label= "MM"
           placeholder="00"
          @change="valueHasChangedss"
          :options="[0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25,26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60]"
        />
        </CCol>
          
         <CCol >
         <CSelect
          label = "SS"
           placeholder="00"
             @change="valueHasChangedmm"
          :options="[0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25,26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60]"
        />
      </CCol>
  
    </CRow>
    <CRow>
   
       <CCol sm="2" > Operator</CCol>
      <CCol sm="3">
        <CInput
            v-model = CurrentEntry.Operator
        />
      </CCol>
    <CCol sm="2" >Shift</CCol>
         <CCol sm="2">
             <select class="form-control form-control-sm" id="Shift"  v-model="CurrentEntry.shift_Id"><option value = 1 >A</option> <option value = 2 >B</option><option value = 3 >C</option></select>
   
      </CCol>
        
    </CRow>


     <CRow>
   
       <CCol sm="2" > Leaf Truck No</CCol>
      <CCol sm="3">
        <div class="form-group">
  
 <select class="form-control" v-model="CurrentEntry.mhE_Id">
    <!-- <option value= "Select Material Type" selected disabled>Select Material Type</option> -->
    <option v-for="mitem in mheitems" :value="mitem.mhE_Id" :key="mitem.mhE_Id">{{ mitem.mhE_Name }} </option>
  </select>
     <div v-if="issw()" >
      Location  
            <CCol sm="5"><select class="form-control" v-model="CurrentEntry.storage_Loc_Id"  >   
              <option v-for="switem in swlocitems" :value="switem.storage_Loc_Id" :key="switem.storage_Loc_Id">{{ switem.storage_Loc_Name }}</option>
           </select>  </CCol>
          
           </div>

</div>
      
      </CCol>
      <CCol sm="2" >Quantity</CCol>
      <CCol sm="3">

        <CInput
          placeholder="00"
             v-model = CurrentEntry.Quantity
        />
        </CCol>
        </CRow>
        <CRow>
        <CCol sm="2" >Truck No</CCol>
        <CCol sm="3">
         <CInput
           placeholder="00"
          v-model = CurrentEntry.TruckNo
        />
        </CCol>
         <CCol sm="3">
           
        <CButton size="sm" color="dark" class="ml-1" @click="SelectEntry(CurrentEntry);validateallfields(); ShowDetailModal=true;"> Print Tag </CButton>
      </CCol>
    </CRow>
     <!-- </CListGroupItem> -->
  </div>

</form>

</div>
</div>
</div>
</div>



</div>
</template>


<script>
   const items = [
  { key: 'formateddate', _style:'min-width:200px' },
  { key: 'ext_Code', _style:'min-width:100px;' },
  { key: 'priority_No', _style:'min-width:50px;' }, 
  { key: 'sch_value',     _style: 'width:1%',  },
  { key: 'size_Code',     _style: 'width:1%',  },
  { key: 'comp_Code',     _style: 'width:1%',  },

 ]
  const apigetsw =  'Trace_Storage_Location_Master/'
 const apiurl =  'Trace_Production/'
 const apigetshedule =  'Trace_Production/GetscheduleForDual_DateFilter/'
const apiwcurl =  'Trace_WorkCenter_Master/'
//import CTableWrapper from '.@/Table.vue' 
import Vue from 'vue'
import axios from 'axios'
import VUEAxios from 'vue-axios'
Vue.use(VUEAxios,axios)

export default {
   //components: { CTableWrapper },
  data ()
  {
    return {
    ShowDetailModal : "",
    items: items.map((item, id) => { return {...item, id}}),
    fields: [
     
           // { key: 'formateddate', label: 'Production Date' },
              { key: 'ext_Code' , label: 'Tread Code',},
              { key: 'priority_No', label: 'Priority' },
              { key: 'sch_value', label: 'Schedule' },             
              { key: 'size_Code',  label: 'Color Code' },
             { key: 'comp_Code',  label: 'Comp Code ' },              
             { key: 'show_details',  label: '',  _style: 'width:30%', },
      ],
   
  
  errMsg:"",
  SuccessMsg:"",
  ShowAddModal:"",
  ShowDeleteModal:"",
  newEntry:"",
  CurrentEntry: {ext_Code:"",Hr:0, SS:"",MM:"",Operator:"",Quantity:0, TruckNo:0,shift_Id:0,mhE_Id:0,priority_No:0,sch_value:0,comp_Code:"",size_Code:"",storage_Loc_Id:0},
  ShowUpdateModal:"",
  smallModal: false,
  newEntry: {material_Id:0,workCent_Id:0,workCenterName:"", prod_Date:new Date(),prod_Time:"",crewDetails:"",prod_Status: 3,truckNumber:0,additionalFields:"",remarks:"",quantity:0,unit_Of_Measurement:"",mhE_Id:0,barcode_Id:0,shift_Id:0,status:1,material_Code:"",priority:0,schedule:0,comp_Code:"",size_Code:"",storage_Loc_Id:0,locSW:""},
  searchdata: {fromdate:"",todate:"", dualid:"" },
  mheitems:"",
  mhename:"",
  wcitems:[],
  wcname:"",
  mheitemsn:[],
  mheitemname:"",
  locSW:"",
  swlocitems:"",
  }
  
  },
  mounted()
  {
     
  // this.getAllMHEDetails();
   this.getAllWorkCentreDetails();

  },

  methods:
  {
     getAllWorkCentreDetails: function()
   {

   Vue.axios.get(this.$url + apiwcurl)
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
       
        this.wcitems = response.data.filter(x => x.status == 1);
       // this.subitems = response.data.fgS_FIFO_WorkCentre_Type_Master;

       }
    });
   },
getAllManualEntryfordate_dual()
{
  var did= this.searchdata.dualid;
  var fdate= this.searchdata.fromdate;
  var tdate= this.searchdata.todate;


  if(did == "")
  {

  }
  else if(fdate=="" || tdate=="")
  {
  
  }
  else if(tdate < fdate)
  {
  this.SuccessMsg = "Please check Date selected"
  this.smallModal = true;
  //location.reload();
  }
  else
  {


   Vue.axios.get(this.$url + apigetshedule +did+'/'+fdate +'/'+tdate)
  .then((response)=>{
  
    if(response.data.error)
       {
         
         this.errMsg=response.data.message;
       }
      else if(response.data.length == 0)
     {
     this.SuccessMsg = "No Schedule available for searched Date. Check Date Selected"
      this.smallModal = true;
     }
    else
       {
        
        this.items =response.data;
       }
    });
}
},
   getAllStorageLocDetails: function()
   {

   Vue.axios.get(this.$url+ apigetsw )
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
        // alert(this.searchdata.dualid)
        this.swlocitems = response.data.filter(x => x.storage_Loc_Status == 1 && x.workCent_Id == this.searchdata.dualid);
       console.log(response.data)
       // this.subitems = response.data.fgS_FIFO_StorageLoc_Type_Master;

       }
    });
   },
valueHasChangedhr(e) {
	this.CurrentEntry.Hr = e.target.value;
	
},


valueHasChangedss(e) {
	this.CurrentEntry.SS = e.target.value;

},
valueHasChangedmm(e) {
	this.CurrentEntry.MM = e.target.value;

},


addToTagGeneration()
  { 
   // alert("inside")
     //CurrentEntry: {ext_Code:"",Hr:"", SS:"",MM:"",Operator:"",Quantity:0, TruckNo:0,shift_Id:0},
   // this.cmonth = this.today.toLocaleString('default', { month: 'short' }),
    // alert(this.cmonth),
   //this.newEntry.inv_TransId =  "",
    //this.newEntry.location_Id= 0,  
    this.newEntry.printer_Name= "canon", 
    this.newEntry.printer_Ip= "192.168.1.12", 
    this.newEntry.printed_DateTime= this.today,
    this.newEntry.module_Name=  "Dual", 
    this.newEntry.print_Status= 0,
   // alert( this.CurrentEntry.ext_Code),
    this.newEntry.tagDetails =  "ext_Code : "+ this.CurrentEntry.ext_Code +"|| Quantity : " +this.CurrentEntry.Quantity +"|| TruckNo :" +this.CurrentEntry.TruckNo +"|| shift_Id :" + this.CurrentEntry.shift_Id ,
    
    //this.newMaterial.entryDate = this.today,
    Vue.axios.post(this.$url + 'Trace_Tag_Generation/',this.newEntry).then((response)=>{

       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
       
        this.SuccessMsg ="Tag Printing in progress..",
    //    this.ShowDetailsModal = false;
        this.smallModal = true;
        //location.reload();
       // getAllMaterialDetails();
        
       }
       
    })
  
   },



  getAllMHEDetails: function()
   {
   
   Vue.axios.get(this.$url+'Trace_MHE_Master')
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {

         if(this.CurrentEntry.ext_Code.includes("SW"))
         {
        this.mheitems = response.data.filter(x => x.mhE_Status == 0 && x.status == 1 && x.mhE_Type == "SW");
         }
         else
         {
            this.mheitems = response.data.filter(x => x.mhE_Status == 0 && x.status == 1 && x.mhE_Type == "LeafTruck");
         }
       // this.subitems = response.data.fgS_FIFO_MHE_Type_Master;
       }
    });
   },
 
  addEntry()
  {

 this.newEntry.workCent_Id = this.searchdata.dualid;
 //this.newEntry.WorkCenterName = 
 this.newEntry.prod_Date = this.CurrentEntry.prod_Date;
 // alert(this.CurrentEntry.prod_Date)
 var time = " " + this.CurrentEntry.Hr + ":" + this.CurrentEntry.MM + ":" + this.CurrentEntry.SS;
this.newEntry.prod_Time = this.newEntry.prod_Date + time;
// alert( this.Pprod_Time)

 alert(this.newEntry.prod_Time)
 
 this.newEntry.crewDetails = this.CurrentEntry.Operator;
 this.newEntry.additionalFields= " ";
 this.newEntry.remarks= "";
 this.newEntry.quantity=this.CurrentEntry.Quantity;
 this.newEntry.unit_Of_Measurement=1;
 this.newEntry.storage_Loc_Id = this.CurrentEntry.storage_Loc_Id;
 this.newEntry.locSW = this.CurrentEntry.storage_Loc_Id;
 this.newEntry.mHE_Id=this.CurrentEntry.mhE_Id;
 
 this.newEntry.truckNumber=this.CurrentEntry.TruckNo;
 this.newEntry.shift_Id=this.CurrentEntry.shift_Id;
 this.newEntry.barcode_Id=0;
 this.newEntry.material_Code = this.CurrentEntry.ext_Code;
 this.newEntry.status=1;
 this.newEntry.print_Status=0;
 this.newEntry.prod_Status = 3;
 this.newEntry.size_Code = this.CurrentEntry.size_Code;
 this.newEntry.priority = this.CurrentEntry.priority_No;
 this.newEntry.comp_Code =  this.CurrentEntry.comp_Code;
 this.newEntry.schedule =  this.CurrentEntry.sch_value;
 this.wcname = this.wcitems.filter(x => x.workCent_Id == this.searchdata.dualid); 
 

 this.newEntry.workCenterName = this.wcname[0].workCent_Name;
 this.mheitemsn = this.mheitems.filter(x => x.mhE_Id ==  this.CurrentEntry.mhE_Id),
 
this.mheitemname = this.mheitemsn[0].mhE_Name;
 this.newEntry.mhename =   this.mheitemname ;
  
 Vue.axios.post(this.$url+ apiurl,this.newEntry).then((response)=>{
    
       if(response.data.error)
       {
          alert('Data Error')
       }
      else if(response.data == "1")
       {
         
      this.SuccessMsg = "Tag generation already done ",
      this.smallModal = true;

       }
       else
       {
       // this.SuccessMsg ="Records Inserted Successfully.."
        this.SuccessMsg ="Tag Printing in progress..";
         this.smallModal = true;
           this.ShowDetailsModal = true;
       // this.addToTagGeneration();
       }
    })
    //}
   },

 validateallfields()
 {
    
  if( this.CurrentEntry.Operator == null || this.CurrentEntry.Operator =="" )
  {
    this.SuccessMsg = "Enter 6 digit Booker Id";
    this.smallModal =  true;
    this.ShowDetailModal = true;
  }
  if( this.CurrentEntry.Operator.length != 6 )
  {
   
    this.SuccessMsg = "Enter 6 digit Booker Id";
    this.smallModal =  true;
    this.ShowDetailModal = true;
  }
  if(this.CurrentEntry.shift_Id  == null  )
  {
    
    this.SuccessMsg = "Please select Shift";
   this.smallModal =  true;
   this.ShowDetailModal = true;
  }
  if(this.CurrentEntry.mhE_Id == null || this.CurrentEntry.mhE_Id == "")
  {
    this.SuccessMsg = "Please select a Leaf Truck";
    this.smallModal =  true;
    this.ShowDetailModal = false;
  }
  if( this.CurrentEntry.Quantity == null)
  {
    
   this.SuccessMsg = "Quantity Cannot Be zero";
   this.smallModal =  true;
   this.ShowDetailModal = true;
  }
  if(this.CurrentEntry.TruckNo == null )
  {
 
  this.SuccessMsg = "Truck Number Cannot Be zero";
  this.smallModal =  true;
  this.ShowDetailModal = true;
  }
if(this.CurrentEntry.MM == null || this.CurrentEntry.MM == null)
{

 this.SuccessMsg = "Kindly check Minutes/Sec..."
this.smallModal = true;
this.ShowDetailModal = true;

}
 // alert(this.CurrentEntry.TruckNo +"/"+ this.CurrentEntry.Quantity  +"/"+ this.CurrentEntry.Operator +"/"+  this.CurrentEntry.mhE_Id)
  if(this.CurrentEntry.TruckNo >= 1 && this.CurrentEntry.Quantity >= 1 && this.CurrentEntry.Operator != "" && this.CurrentEntry.mhE_Id >= 1 && this.CurrentEntry.Operator.length == 6) 
  {
    
    this.addEntry() ;
    this.CurrentEntry.Quantity = 0;
    this.CurrentEntry.TruckNo = 0;
    this.ShowDetailModal = true;

    
  }

 },
      
  SelectEntry(Entry)
    {
    
     this.CurrentEntry=Entry;
      this.CurrentEntry.prod_Date=this.CurrentEntry.prod_Date.slice(0,10);


     },

         
 issw()
  {
     
      if (this.CurrentEntry.ext_Code.includes("SW"))
      {  return true;   }
       else 
      {    return false;  }
    },
 
      
 
  },
    
    
    }
  
    


</script>

<style scoped>
#overlay{
  position:fixed;
  top:100px;
  bottom:0;
  left:0;
  right:0;
  background:rgba(0,0,0,0.6);
}
</style>